using System;

// custom reference type
class CustomRefType
{
  public int myRefCount;
}

// main program type
class RefAndVal
{
  // value type passed by reference
  public static int IncrementValByRef(ref int myCountValParam)
  {
    return ++myCountValParam;
  }

  // reference type passed by value
  public static void IncrementRefByVal(CustomRefType myRefType)
  {
    myRefType.myRefCount++;
    myRefType = new CustomRefType();
    myRefType.myRefCount = -1;
  }

  // reference type passed by reference
  public static void IncrementRefByRef(ref CustomRefType myRefType)
  {
    myRefType.myRefCount++;
    myRefType = new CustomRefType();
    myRefType.myRefCount = -1;
  }

  static void Main()
  {
    // value type passed by reference
	int myCount     = 0;
	int myIncrement = 0;

    Console.WriteLine("// Value Type Passed by Reference.");
    Console.WriteLine("Before:");
    Console.WriteLine("myCount: {0}\nmyIncrement: {1}",
	  myCount, myIncrement);

	myIncrement = IncrementValByRef(ref myCount);

	Console.WriteLine("After:");
    Console.WriteLine("myCount: {0}\nmyIncrement: {1}",
      myCount, myIncrement);

    // reference type passed by value
    CustomRefType myRefType = new CustomRefType();

    Console.WriteLine("\n// Reference Type Passed by Value.");
    Console.WriteLine("Before:");
    Console.WriteLine("myRefType.myRefCount: {0}",
      myRefType.myRefCount);

    IncrementRefByVal(myRefType);

    Console.WriteLine("After:");
    Console.WriteLine("myRefType.myRefCount: {0}",
      myRefType.myRefCount);

    // reference type passed by reference
    myRefType.myRefCount = 0;
    CustomRefType myOldRefType = myRefType;


    Console.WriteLine("\n// Reference Type Passed by Reference.");
    Console.WriteLine("Before:");
    Console.WriteLine("myRefType.myRefCount: {0}",
      myRefType.myRefCount);
    Console.WriteLine("myOldRefType.myRefCount: {0}",
      myOldRefType.myRefCount);

    IncrementRefByRef(ref myRefType);

    Console.WriteLine("After:");
    Console.WriteLine("myRefType.myRefCount: {0}",
      myRefType.myRefCount);
    Console.WriteLine("myOldRefType.myRefCount: {0}\n",
      myOldRefType.myRefCount);

    Console.ReadLine();
  }
}

