using System;
using System.IO;

class TryCatchFinally
{
  static void Main()
  {
    Stream stream = null;

    try
    {
      stream = new FileStream(
        "MyFile.txt",
        FileMode.OpenOrCreate,
        FileAccess.Read);

      stream.Write(new byte[] {1, 2, 3}, 0, 3);
    }
    catch (IOException ioe)
    {
	  Console.WriteLine("Caught IOException: \n\n" + ioe.ToString());
    }
    catch (Exception ex)
	{
	  Console.WriteLine("Caught Exception: \n\n" + ex.ToString());
    }
    finally
	{
	   Console.WriteLine("\nExecuting Finally Block.");
	   
	   if (stream != null)
		  stream.Close();
    }

    Console.ReadLine();
  }
}

