using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace CapsAndJoins
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ComboBox cboCaps;
		private System.Windows.Forms.ComboBox cboJoins;

		public WinForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			cboCaps.Items.AddRange(
				Enum.GetNames(typeof(System.Drawing.Drawing2D.LineCap)));

			cboCaps.SelectedIndex = 0;


			cboJoins.Items.AddRange(
				Enum.GetNames(typeof(System.Drawing.Drawing2D.LineJoin)));

			cboJoins.SelectedIndex = 0;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cboCaps = new System.Windows.Forms.ComboBox();
			this.cboJoins = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// cboCaps
			// 
			this.cboCaps.Location = new System.Drawing.Point(16, 232);
			this.cboCaps.Name = "cboCaps";
			this.cboCaps.Size = new System.Drawing.Size(121, 21);
			this.cboCaps.TabIndex = 0;
			this.cboCaps.SelectedIndexChanged += new System.EventHandler(this.cboCaps_SelectedIndexChanged);
			// 
			// cboJoins
			// 
			this.cboJoins.Location = new System.Drawing.Point(152, 232);
			this.cboJoins.Name = "cboJoins";
			this.cboJoins.Size = new System.Drawing.Size(121, 21);
			this.cboJoins.TabIndex = 1;
			this.cboJoins.SelectedIndexChanged += new System.EventHandler(this.cboJoins_SelectedIndexChanged);
			// 
			// WinForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.cboJoins);
			this.Controls.Add(this.cboCaps);
			this.Name = "WinForm";
			this.Text = "WinForm";
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new WinForm());
		}


		protected override void OnPaint(PaintEventArgs pea)
		{
 			base.OnPaint(pea);

			const int borderOffset = 30;
			int startX = borderOffset;
			int midX   = ClientRectangle.Width / 2;
			int endX   = ClientRectangle.Width - borderOffset;
			int startY = borderOffset;
			int endY   = ClientRectangle.Height - (borderOffset * 2);

			Point[] points =
			{
				new Point(startX, endY),
				new Point(midX,   startY),
				new Point(endX,   endY)
			};

			Pen thickPen = new Pen(ForeColor);
			Pen thinPen  = new Pen(BackColor);

			const int ThinPenWidth  = 3;
			const int ThickPenWidth = 20;

			thickPen.MiterLimit = 1.2f;

			thinPen.Width  = ThinPenWidth;
			thickPen.Width = ThickPenWidth;

			thickPen.LineJoin = (System.Drawing.Drawing2D.LineJoin)Enum.Parse(
				typeof(System.Drawing.Drawing2D.LineJoin),
				cboJoins.SelectedItem.ToString());
			thickPen.StartCap = (System.Drawing.Drawing2D.LineCap)Enum.Parse(
				typeof(System.Drawing.Drawing2D.LineCap),
				cboCaps.SelectedItem.ToString());

			thickPen.EndCap = thickPen.StartCap;
			
			Graphics g = pea.Graphics;

			g.DrawLines(thickPen, points);
			g.DrawLines(thinPen,  points);
		}
		
		private void cboCaps_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Invalidate();
		}

		private void cboJoins_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Invalidate();
		}
	}
}
