using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Clearing
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public WinForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			ResizeRedraw = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.Size = new System.Drawing.Size(300,300);
			this.Text = "WinForm";
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new WinForm());
		}


		protected override void OnPaint(PaintEventArgs pea)
		{
			base.OnPaint(pea);

			Graphics g = pea.Graphics;

			g.Clear(BackColor);

			StringFormat strFormat = new StringFormat();

			int Height = ClientRectangle.Height;
			int Width  = ClientRectangle.Width;

			Random rand = new Random();
			int x = rand.Next(Width);
			int y = rand.Next(Height);

			strFormat.Alignment = StringAlignment.Center;
			strFormat.LineAlignment = StringAlignment.Center;

			g.DrawString("Welcome to C#Builder Kick Start!",
				Font, new SolidBrush(ForeColor),
				x, y, strFormat);
		}

	}
}
