using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DashStyle
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ComboBox cboDashStyle;
		private System.Windows.Forms.NumericUpDown nudPenWidth;

		public WinForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			cboDashStyle.Items.AddRange(
				Enum.GetNames(typeof(System.Drawing.Drawing2D.DashStyle)));

			cboDashStyle.SelectedIndex = 0;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cboDashStyle = new System.Windows.Forms.ComboBox();
			this.nudPenWidth = new System.Windows.Forms.NumericUpDown();
			((System.ComponentModel.ISupportInitialize)(this.nudPenWidth)).BeginInit();
			this.SuspendLayout();
			// 
			// cboDashStyle
			// 
			this.cboDashStyle.Location = new System.Drawing.Point(152, 224);
			this.cboDashStyle.Name = "cboDashStyle";
			this.cboDashStyle.Size = new System.Drawing.Size(121, 21);
			this.cboDashStyle.TabIndex = 0;
			this.cboDashStyle.Text = "comboBox1";
			this.cboDashStyle.SelectedIndexChanged += new System.EventHandler(this.cboDashStyle_SelectedIndexChanged);
			// 
			// nudPenWidth
			// 
			this.nudPenWidth.Location = new System.Drawing.Point(16, 224);
			this.nudPenWidth.Maximum = new System.Decimal(new int[] {
						50,
						0,
						0,
						0});
			this.nudPenWidth.Minimum = new System.Decimal(new int[] {
						1,
						0,
						0,
						0});
			this.nudPenWidth.Name = "nudPenWidth";
			this.nudPenWidth.TabIndex = 1;
			this.nudPenWidth.Value = new System.Decimal(new int[] {
						1,
						0,
						0,
						0});
			this.nudPenWidth.ValueChanged += new System.EventHandler(this.nudPenWidth_ValueChanged);
			// 
			// WinForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.nudPenWidth);
			this.Controls.Add(this.cboDashStyle);
			this.Name = "WinForm";
			this.Text = "WinForm";
			((System.ComponentModel.ISupportInitialize)(this.nudPenWidth)).EndInit();
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new WinForm());
		}

		protected override void OnPaint(PaintEventArgs pea)
		{
 			base.OnPaint(pea);

			const int borderOffset = 15;
			int startX = borderOffset;
			int endX   = ClientRectangle.Width - borderOffset;
			int startY = ClientRectangle.Height / 2 - borderOffset;
			int endY = startY;
			
			Point lineStart = new Point(startX, startY);
			Point lineEnd   = new Point(endX,   endY);

			Pen pen = new Pen(ForeColor);

			pen.Width = Int32.Parse(nudPenWidth.Text);
			pen.DashStyle =
				(System.Drawing.Drawing2D.DashStyle)Enum.Parse(
					typeof(System.Drawing.Drawing2D.DashStyle),
					cboDashStyle.SelectedItem.ToString());

			Graphics g = pea.Graphics;

			g.DrawLine(pen, lineStart, lineEnd);
		}
		
		private void nudPenWidth_ValueChanged(object sender, System.EventArgs e)
		{
			Invalidate();
		}
		
		private void cboDashStyle_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Invalidate();
		}
	}
}
