using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using OkCancelApply;

namespace ControlDemoDialog
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class ControlDemoDialog : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private OkCancelApply.OkCancelApply okCancelApply;
		private System.Windows.Forms.TextBox txtInput;
		private System.Windows.Forms.Label lblInput;

		public ControlDemoDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			okCancelApply.Click += new EventHandler(ControlClicked);
		}

		public void ControlClicked(object sender, System.EventArgs e)
		{
			DialogButton selectedButton = okCancelApply.ClickedButton;

			string format =
				"You selected the {0} button and \n" +
				"your input was '{1}'.";
			string message = String.Format(
				format,
				selectedButton,
				txtInput.Text);
				
			MessageBox.Show(message, "Control Clicked");
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.okCancelApply = new OkCancelApply.OkCancelApply();
			this.txtInput = new System.Windows.Forms.TextBox();
			this.lblInput = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// okCancelApply
			// 
			this.okCancelApply.ClickedButton = OkCancelApply.DialogButton.Cancel;
			this.okCancelApply.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.okCancelApply.Location = new System.Drawing.Point(0, 102);
			this.okCancelApply.Name = "okCancelApply";
			this.okCancelApply.Size = new System.Drawing.Size(280, 40);
			this.okCancelApply.TabIndex = 0;
			// 
			// txtInput
			// 
			this.txtInput.Location = new System.Drawing.Point(32, 56);
			this.txtInput.Name = "txtInput";
			this.txtInput.Size = new System.Drawing.Size(208, 20);
			this.txtInput.TabIndex = 1;
			this.txtInput.Text = "";
			// 
			// lblInput
			// 
			this.lblInput.Location = new System.Drawing.Point(32, 24);
			this.lblInput.Name = "lblInput";
			this.lblInput.TabIndex = 2;
			this.lblInput.Text = "Input:";
			this.lblInput.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// WinForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(280, 142);
			this.Controls.Add(this.lblInput);
			this.Controls.Add(this.txtInput);
			this.Controls.Add(this.okCancelApply);
			this.Name = "WinForm";
			this.Text = "Control Demo Dialog";
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new ControlDemoDialog());
		}
	}
}
