using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace MathTest
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.IContainer components;
		private MathLibrary.MathComponent mathComponent;
		private System.Windows.Forms.Label lblFirstNumber;
		private System.Windows.Forms.Label lblSecondNumber;
		private System.Windows.Forms.Label lblResult;
		private System.Windows.Forms.TextBox txtFirstNumber;
		private System.Windows.Forms.TextBox txtSecondNumber;
		private System.Windows.Forms.Label lblResultOutput;
		private System.Windows.Forms.Button btnAdd;
		private System.Windows.Forms.Button btnSubtract;

		public WinForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.mathComponent = new MathLibrary.MathComponent(this.components);
			this.lblFirstNumber = new System.Windows.Forms.Label();
			this.lblSecondNumber = new System.Windows.Forms.Label();
			this.lblResult = new System.Windows.Forms.Label();
			this.txtFirstNumber = new System.Windows.Forms.TextBox();
			this.txtSecondNumber = new System.Windows.Forms.TextBox();
			this.lblResultOutput = new System.Windows.Forms.Label();
			this.btnAdd = new System.Windows.Forms.Button();
			this.btnSubtract = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// lblFirstNumber
			// 
			this.lblFirstNumber.Location = new System.Drawing.Point(24, 40);
			this.lblFirstNumber.Name = "lblFirstNumber";
			this.lblFirstNumber.TabIndex = 0;
			this.lblFirstNumber.Text = "First Number:";
			this.lblFirstNumber.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblSecondNumber
			// 
			this.lblSecondNumber.Location = new System.Drawing.Point(24, 80);
			this.lblSecondNumber.Name = "lblSecondNumber";
			this.lblSecondNumber.TabIndex = 1;
			this.lblSecondNumber.Text = "Second Number:";
			this.lblSecondNumber.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblResult
			// 
			this.lblResult.Location = new System.Drawing.Point(24, 120);
			this.lblResult.Name = "lblResult";
			this.lblResult.TabIndex = 2;
			this.lblResult.Text = "Result:";
			this.lblResult.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtFirstNumber
			// 
			this.txtFirstNumber.Location = new System.Drawing.Point(144, 40);
			this.txtFirstNumber.Name = "txtFirstNumber";
			this.txtFirstNumber.TabIndex = 3;
			this.txtFirstNumber.Text = "";
			// 
			// txtSecondNumber
			// 
			this.txtSecondNumber.Location = new System.Drawing.Point(144, 80);
			this.txtSecondNumber.Name = "txtSecondNumber";
			this.txtSecondNumber.TabIndex = 4;
			this.txtSecondNumber.Text = "";
			// 
			// lblResultOutput
			// 
			this.lblResultOutput.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblResultOutput.Location = new System.Drawing.Point(144, 120);
			this.lblResultOutput.Name = "lblResultOutput";
			this.lblResultOutput.TabIndex = 5;
			this.lblResultOutput.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// btnAdd
			// 
			this.btnAdd.Location = new System.Drawing.Point(40, 200);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.TabIndex = 6;
			this.btnAdd.Text = "Add";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			// 
			// btnSubtract
			// 
			this.btnSubtract.Location = new System.Drawing.Point(160, 200);
			this.btnSubtract.Name = "btnSubtract";
			this.btnSubtract.TabIndex = 7;
			this.btnSubtract.Text = "Subtract";
			this.btnSubtract.Click += new System.EventHandler(this.btnSubtract_Click);
			// 
			// WinForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.btnSubtract);
			this.Controls.Add(this.btnAdd);
			this.Controls.Add(this.lblResultOutput);
			this.Controls.Add(this.txtSecondNumber);
			this.Controls.Add(this.txtFirstNumber);
			this.Controls.Add(this.lblResult);
			this.Controls.Add(this.lblSecondNumber);
			this.Controls.Add(this.lblFirstNumber);
			this.Name = "WinForm";
			this.Text = "Math Test";
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new WinForm());
		}
		
		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			int n1 = Int32.Parse(txtFirstNumber.Text);
			int n2 = Int32.Parse(txtSecondNumber.Text);

			lblResultOutput.Text = mathComponent.Add(n1, n2).ToString();
		}

		private void btnSubtract_Click(object sender, System.EventArgs e)
		{
			int n1 = Int32.Parse(txtFirstNumber.Text);
			int n2 = Int32.Parse(txtSecondNumber.Text);

			lblResultOutput.Text = mathComponent.Subtract(n1, n2).ToString();
		}
	}
}
