using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

[assembly:TagPrefix("MarqueeControl", "csb")]

namespace MarqueeControl
{
	[DefaultProperty("Text"),
		ToolboxData("<{0}:MarqueeTextOut runat=server></{0}:MarqueeTextOut>")]
	public class MarqueeTextOut : System.Web.UI.WebControls.WebControl
	{
		private string text;
	
		[Bindable(true), 
			Category("Appearance"), 
			DefaultValue("")]
		public string Text
		{
			get
			{
				return text;
			}

			set
			{
				text = value;
			}
		}

		/// <summary> 
		/// Render this control to the output parameter specified.
		/// </summary>
		/// <param name="output"> The HTML writer to write out to </param>
		protected override void Render(HtmlTextWriter output)
		{
			string html = @"
<marquee direction=""up""
		 width=""200px"">
  <center>
	<p>
	  This is a Marquee Control.
	</p>
	<p>
	  This is another line.
    </p>
  </center>
</marquee>";

			output.Write(html);
		}
	}
}
