using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.Services.Protocols;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace DataClient
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class DataClient : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnInsert;
		protected System.Web.UI.WebControls.DataGrid dgrProducts;
		protected System.Web.UI.WebControls.Label lblMessage;
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				LoadData();
			}
		}

		private void LoadData()
		{
			ProductsTableService pts = new ProductsTableService();
			DataSet ds = pts.GetProducts();

			dgrProducts.DataSource = ds;
			dgrProducts.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnInsert.Click += new System.EventHandler(this.btnInsert_Click);
			this.dgrProducts.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.dgrProducts_CancelCommand);
			this.dgrProducts.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.dgrProducts_EditCommand);
			this.dgrProducts.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.dgrProducts_UpdateCommand);
			this.dgrProducts.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.dgrProducts_DeleteCommand);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
		
		private void btnInsert_Click(object sender, System.EventArgs e)
		{
			ProductsTableService pts = new ProductsTableService();

			pts.InsertProduct("New", "1", 0.00f);

			LoadData();
		}

		private void dgrProducts_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			dgrProducts.EditItemIndex = e.Item.ItemIndex;

			Session["ProductName"]     = e.Item.Cells[2].Text;
			Session["QuantityPerUnit"] = e.Item.Cells[3].Text;
			Session["UnitPrice"]       = e.Item.Cells[4].Text;

			LoadData();
		}
		
		private void dgrProducts_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			dgrProducts.EditItemIndex = -1;
			LoadData();
		}
		
		private void dgrProducts_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			string productName     = e.Item.Cells[2].Text;
			string quantityPerUnit = e.Item.Cells[3].Text;
			float  unitPrice       = Single.Parse(e.Item.Cells[4].Text);

			ProductsTableService pts = new ProductsTableService();
			pts.DeleteProduct(productName, quantityPerUnit, unitPrice);

			dgrProducts.EditItemIndex = -1;
			LoadData();
		}

		private void dgrProducts_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			try
			{
				TextBox txtProdName = (TextBox)e.Item.Cells[2].Controls[0];
				TextBox txtQtyUnit  = (TextBox)e.Item.Cells[3].Controls[0];
				TextBox txtUnPrice  = (TextBox)e.Item.Cells[4].Controls[0];

				string newProductName     = txtProdName.Text;
				string newQuantityPerUnit = txtQtyUnit.Text;
				float  newUnitPrice       = Single.Parse(txtUnPrice.Text);

				string oldProductName     = (string)Session["ProductName"];
				string oldQuantityPerUnit = (string)Session["QuantityPerUnit"];
				float  oldUnitPrice       = Single.Parse((string)Session["UnitPrice"]);

				ProductsTableService pts = new ProductsTableService();
				pts.UpdateProduct(newProductName, newQuantityPerUnit, newUnitPrice, oldProductName, oldQuantityPerUnit, oldUnitPrice);
			}
			catch (Exception ex)
			{
				lblMessage.Text = ex.ToString();
			}
			finally
			{
				dgrProducts.EditItemIndex = -1;
				LoadData();
			}
		}
	}
}

